#version 120

uniform sampler2D tex;

void main()
{
	float fog_factor = exp2(-gl_Fog.density * gl_FogFragCoord);
	fog_factor = clamp(fog_factor, 0.0, 0.8); // XXX 0.9 -> always 0.1 fogged
	vec4 tex_color = texture2D(tex, gl_TexCoord[0].xy);
	vec4 fog_color = vec4(gl_Fog.color.rgb, tex_color.a);

	gl_FragColor = mix(fog_color, tex_color, fog_factor);
}

