#version 120

uniform vec3	campos;
uniform vec3	wdir;
uniform float	wstr;

const float PI = 3.14159265;

vec4 get_dir(float x, float z)
{
	float a = mod(x + z, 5.0) / 4.0 * 2.0*PI;

	return vec4(sin(a), 0.0, cos(a), 0.0);
}

void main()
{
	vec4 vert = gl_Vertex;

	// Simulate wind effect.
	// use texture coords to determine the upper vertices
	if (gl_MultiTexCoord0.y < 1.0) {
		vec4 dir = vec4(wdir, 0.0) + get_dir(vert.x, vert.z);
		vert += dir * wstr;
	}

	// Sink grass into the ground so that the grass area boundary is less
	// visible. sink_dist is the distance where grass is completely below
	// ground.
	const float sink_dist = 40.0f;
	vert.y -= clamp(distance(campos.xz, vert.xz) / sink_dist, 0.0, 1.0);

	gl_Position = gl_ModelViewProjectionMatrix * vert;

	gl_FrontColor = gl_Color;
	gl_TexCoord[0] = gl_MultiTexCoord0;

	vec4 cam_space_position = gl_ModelViewMatrix * vert;
	gl_FogFragCoord = length(cam_space_position.xyz);
}

