#version 120

uniform sampler2D tex;

void main()
{
	/*
	float fog = (gl_Fog.end - gl_FogFragCoord) * gl_Fog.scale;
	fog = clamp(fog, 0.0, 1.0);

	vec4 tex_color = vec4(texture2D(tex, gl_TexCoord[0].xy).rgb, gl_Color.a);
	vec4 fog_color = vec4(gl_Fog.color.rgb, gl_Color.a);
	*/

	// [0.0,0.5]
	float fade_start = 0.49;
	float fade_len = 0.5 - fade_start;

	vec2 uv = gl_TexCoord[0].st - vec2(0.5);
	float s = clamp(abs(uv.s) - fade_start, 0.0, fade_len) / fade_len;
	float t = clamp(abs(uv.t) - fade_start, 0.0, fade_len) / fade_len;
	float alpha = min(1.0 - s, 1.0 - t);

	float fog_factor = exp2(-gl_Fog.density * gl_FogFragCoord) * 1.15 /* XXX */;
	fog_factor = clamp(fog_factor, 0.0, 0.8); // XXX 0.9 -> always 0.1 fogged
	vec4 tex_color = vec4(texture2D(tex, gl_TexCoord[0].xy).rgb, alpha);
	vec4 fog_color = vec4(gl_Fog.color.rgb, tex_color.a);

	gl_FragColor = mix(fog_color, tex_color, fog_factor);
}

